# Master 1 - Projet de Spécialité

Ce projet consiste en une application Android permettant à des enseignants de créer des session de cours où un ensemble
d'élève est assigné à des tâches qui peuvent être validées de manière collaborative.

Voici les fonctionnalités proposées : 
- Connexion entre plusieurs appareils en IP ou Wi-Fi Direct
- Création de session de cours contenant une classe et des enseignants
- Authentification à l'aide du QR code présent sur les cartes étudiantes
- Support de différents sujets composés de différentes questions pour chaqu'un des élèves
- Possibilité pour un enseignant de rejoindre la connexion pour valider collaborativement les tâches des élèves
- Possibilité pour un étudiant de rejoindre la connexion pour vérifier les tâches validées
- Exportation des données dans un fichier `JSON`
- Validation rapide permettant de valider la tâche suivante d'un élève à l'aide de son QR code

# Build

1. Cloner le projet à l'aide de la commande `git clone https://git.faraphel.fr/study-faraphel/M1-PDS`
2. Ouvrer le dans [Android Studio](https://developer.android.com/studio?hl=fr) ou [Intellij IDEA](https://www.jetbrains.com/idea/)
3. Activer le [menu développeur](https://developer.android.com/studio/debug/dev-options) 
   sur votre téléphone (rendez-vous dans les paramètres, trouver une page information contenant votre version d'Android, cliquer 
   plusieurs fois dessus jusqu'à ce qu'un message vous informe que le menu développeur à été débloqué), puis activer le 
   mode débuggage.
4. Sélectionner votre téléphone dans le [menu de configuration](https://www.jetbrains.com/help/idea/run-debug-configuration.html) 
   (l'utilisation d'émulateur n'est pas préconisé pour la fonctionnalité Wi-Fi Direct)
5. Démarrer l'application avec le bouton `Run`

# Problèmes Courants

## Permissions

Les dernières versions d'Android ont beaucoup changé les permissions, particulièrement les permissions de localisation et d'accès aux fichiers.
Il peut être nécessaire de manuellement activer les permissions en se rendant dans les paramètres du téléphone, de se rendre dans les menus de permissions des applications et de leur autoriser les permissions de localisation et de photo.

> Pourquoi les permissions de positions sont nécessaire ?

Les technologies de communication comme le Wi-Fi Direct peuvent techniquement permettre à quelqu'un qui chercherait à vous pister de trouver la position de votre téléphone à l'aide du signal Wi-Fi Direct permettant de vous identifier.
Pour des raisons de sécurité, le système Android demande donc à l'utilisateur d'accepter les permissions de localisation si l'on souhaite utiliser la technologie Wi-Fi Direct.
En aucun cas cette application n'essaye d'accéder à votre position GPS. Il s'agit d'une simple sécurité d'Android pour faire prendre conscience d'une potentielle dérive de la capacité à rechercher des téléphones sur le réseau.