package com.faraphel.tasks_valider.ui.screen.communication.authentication

import androidx.compose.foundation.layout.*
import androidx.compose.material3.Button
import androidx.compose.material3.Text
import androidx.compose.material3.TextField
import androidx.compose.runtime.Composable
import androidx.compose.runtime.MutableState
import androidx.compose.runtime.mutableStateOf
import androidx.compose.runtime.remember
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.unit.dp
import androidx.compose.ui.unit.sp
import com.faraphel.tasks_valider.connectivity.task.session.TaskRole
import com.faraphel.tasks_valider.database.entities.PersonEntity


/**
 * Authentification screen where the host can give his information
 */
@Composable
fun AuthenticationServerScreen(personEntity: MutableState<PersonEntity?>) {
    val firstName = remember { mutableStateOf("") }
    val lastName = remember { mutableStateOf("") }

    Column(
        modifier = Modifier.fillMaxSize(),
        verticalArrangement = Arrangement.Center,
        horizontalAlignment = Alignment.CenterHorizontally
    ) {
        // title
        Text(
            text = "Your Profile",
            fontSize = 32.sp
        )

        // separator
        Spacer(modifier = Modifier.height(24.dp))

        // first name
        TextField(
            value = firstName.value,
            placeholder = { Text("first name") },
            onValueChange = { text -> firstName.value = text },
        )

        // last name
        TextField(
            value = lastName.value,
            placeholder = { Text("last name") },
            onValueChange = { text -> lastName.value = text },
        )

        // separator
        Spacer(modifier = Modifier.height(24.dp))

        // confirm button
        Button(onClick = {
            // create the person entity with the given information
            personEntity.value = PersonEntity(
                firstName = firstName.value,
                lastName = lastName.value,
                role = TaskRole.ADMIN
            )
        }) {
            Text("Submit")
        }
    }
}
