package com.faraphel.tasks_valider.ui.screen.communication.connection.internet

import android.app.Activity
import androidx.compose.foundation.layout.*
import androidx.compose.material3.Button
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.unit.dp
import androidx.compose.ui.unit.sp
import androidx.navigation.NavController
import androidx.navigation.compose.NavHost
import androidx.navigation.compose.composable
import androidx.navigation.compose.rememberNavController
import com.faraphel.tasks_valider.database.TaskDatabase
import com.faraphel.tasks_valider.ui.screen.communication.connection.internet.role.CommunicationInternetClientScreen
import com.faraphel.tasks_valider.ui.screen.communication.connection.internet.role.CommunicationInternetServerScreen


@Composable
fun CommunicationInternetSelectScreen(activity: Activity, database: TaskDatabase) {
    val controller = rememberNavController()

    NavHost(navController = controller, startDestination = "mode") {
        composable("mode") { CommunicationInternetSelectContent(controller) }
        composable("client") { CommunicationInternetClientScreen(activity) }
        composable("server") { CommunicationInternetServerScreen(activity, database) }
    }
}


@Composable
fun CommunicationInternetSelectContent(controller: NavController) {
    Column(
        modifier = Modifier.fillMaxSize(),
        verticalArrangement = Arrangement.Center,
        horizontalAlignment = Alignment.CenterHorizontally
    ) {
        // title
        Text(
            text = "Role",
            fontSize = 32.sp
        )

        // separator
        Spacer(modifier = Modifier.height(24.dp))

        // client mode
        Button(onClick = { controller.navigate("client") }) { Text("Client") }
        // server mode
        Button(onClick = { controller.navigate("server") }) { Text("Server") }
    }
}
