package com.faraphel.tasks_valider.ui.screen.communication.connection.wifiP2p

import android.annotation.SuppressLint
import android.app.Activity
import androidx.compose.foundation.layout.*
import androidx.compose.material3.Button
import androidx.compose.material3.Text
import androidx.compose.runtime.Composable
import androidx.compose.runtime.remember
import androidx.compose.ui.Alignment
import androidx.compose.ui.Modifier
import androidx.compose.ui.unit.dp
import androidx.compose.ui.unit.sp
import androidx.navigation.NavController
import androidx.navigation.compose.NavHost
import androidx.navigation.compose.composable
import androidx.navigation.compose.rememberNavController
import com.faraphel.tasks_valider.connectivity.bwd.BwdManager
import com.faraphel.tasks_valider.connectivity.bwd.BwdManager.Companion.ALL_INTENT_FILTER
import com.faraphel.tasks_valider.database.TaskDatabase
import com.faraphel.tasks_valider.ui.screen.communication.connection.wifiP2p.role.CommunicationWifiP2pClientScreen
import com.faraphel.tasks_valider.ui.screen.communication.connection.wifiP2p.role.CommunicationWifiP2pServerScreen


@Composable
fun CommunicationWifiP2pScreen(activity: Activity, database: TaskDatabase) {
    val controller = rememberNavController()

    // create the Wi-Fi Direct manager
    val bwdManager = remember { BwdManager.fromActivity(activity) }

    NavHost(navController = controller, startDestination = "mode") {
        composable("mode") { CommunicationWifiP2pSelectContent(controller) }
        composable("client") { CommunicationWifiP2pClientScreen(activity, bwdManager) }
        composable("server") { CommunicationWifiP2pServerScreen(activity, database, bwdManager) }
    }
}



@Composable
fun CommunicationWifiP2pSelectContent(controller: NavController) {
    Column(
        modifier = Modifier.fillMaxSize(),
        verticalArrangement = Arrangement.Center,
        horizontalAlignment = Alignment.CenterHorizontally
    ) {
        // title
        Text(
            text = "Role",
            fontSize = 32.sp
        )

        // separator
        Spacer(modifier = Modifier.height(24.dp))

        // client mode
        Button(onClick = { controller.navigate("client") }) { Text("Client") }
        // server mode
        Button(onClick = { controller.navigate("server") }) { Text("Server") }
    }
}
