package com.faraphel.tasks_valider.utils

import fi.iki.elonen.NanoHTTPD
import java.nio.charset.Charset


/**
 * Return the body of a request as a string.
 * :param charset: the encoding of the body
 */
fun NanoHTTPD.IHTTPSession.getBody(
    charset: Charset = Charset.forName("UTF-8")
): String {
    // get the length of the body
    val length = this.headers["content-length"]!!.toInt()
    // prepare a buffer for the body
    val buffer = ByteArray(length)
    // read the body into the buffer
    this.inputStream.read(buffer, 0, length)
    // convert that buffer into a string
    return buffer.toString(charset)
}
